function [Z,w,Factors,ErrList] = R1MC(X, Omega, maxIter, epsilon,FixR)
%%% Last Update on 06/29/2016. Copyright by Qiquan SHI
% Initialization

DimX = ndims(X);
sizeX = size(X);
X(~Omega)=mean(mean(X));  % Set the missing elements as 0, you also can try mean of observed elements;
w=rand(FixR,1);
for i = 1 : DimX
    U0{i} = rand(sizeX(i),FixR);
    temp=sqrt(sum(U0{i}.^2,1));
    U0{i}= U0{i}./((ones(size(U0{i},1),1))*temp);
end
U=U0{1};
V=U0{2};

ErrList = zeros(maxIter, 1);

Z=zeros(sizeX);

%% Iteration Scheme

for k = 1: maxIter
    [U, S, V]=rsvd(X,FixR);
    w=diag(S);
    Z=U*diag(w)*V';
    X(~Omega) = Z(~Omega);
    
    %% Check the stop criteria
    stopC=0;
    error= X(Omega) - Z(Omega);
    stopC = max(stopC, norm(error(:))/norm(X(Omega)));
    ErrList(k,1) = stopC;
    if stopC < epsilon
        break;
    end
    if mod(k, 200) == 0
        fprintf('\n----------L1MC-RF: iterations = %d, **** difference= %5d-----\n', k, ErrList(k,1) );
    end
end

Factors=[{U},{V}];
end